#include <bits/stdc++.h>
 
using namespace std;
 
int main() {
	char a[10][10];
	int black=0, tri=0, dva=0, odin=0, four=0;
	for (int i=0; i<10; i++) {
		for (int j=0; j<10; j++) {
			cin >> a[i][j];
			if (a[i][j] == '#') {
				black++;
			}
		}
	}
	if (black != 20) {
		cout << "NO";
		return 0;
	}
	for (int i=0; i<10; i++) {
		int podradblack=0;
		for (int j=0; j<10; j++) {
			if (a[i][j] == '#') {
				podradblack++;
			} 
			else {
				if (podradblack == 1) {
					odin++;
				} 
				if (podradblack == 2) {
					dva++;
				} 
				if (podradblack == 3) {
					tri++;
				} 
				if (podradblack == 4) {
					four++;
				} 
				podradblack=0;
			}
		}
		if (podradblack == 1) {
			odin++;
		} 
		if (podradblack == 2) {
			dva++;
		} 
		if (podradblack == 3) {
			tri++;
		} 
		if (podradblack == 4) {
			four++;
		} 
	}
	for (int i=0; i<10; i++) {
		int podradblack=0;
		for (int j=0; j<10; j++) {
			if (a[j][i] == '#') {
				podradblack++;
			} 
			else {
				if (podradblack == 1) {
					odin++;
				} 
				if (podradblack == 2) {
					dva++;
				} 
				if (podradblack == 3) {
					tri++;
				} 
				if (podradblack == 4) {
					four++;
				} 
				podradblack=0;
			}
		}
		if (podradblack == 1) {
			odin++;
		} 
		if (podradblack == 2) {
			dva++;
		} 
		if (podradblack == 3) {
			tri++;
		} 
		if (podradblack == 4) {
			four++;
		} 
	}
	if (odin==4&&dva==3&&tri==2&&four==1) {
		cout << "YES";
	}
	else {
		cout << "NO";
	}
}
